// ef_store for TEE  ------------------------------------------------
// TEE, 03.07.2002, TU Dresden, R. Kraue, EF-Version 0.85

var mStore;
var SolvedStore;
var iHintStore;
var TargetTextStore;
var win;

function SGetElAI(nr, i)
{
  return eval("win.document.forms[0].a"+nr+"["+i+"]");
}

function SGetElA(nr)
{
  return eval("win.document.forms[0].a"+nr);
}

function StoreHard(TheWin)
{
  win = TheWin;
  if ( !win.Type )
    return;
  for (var nr = 0; nr < win.Type.length; nr++)
  {
    if ( eval("win.document.sr"+nr) ) // preprocess SR (MCA)
    {
      var sr = eval("win.document.sr"+nr)
      if ( sr.modified != 0 )
        SGetElA(nr).value = sr.value;
    }
    if ( win.document.applets["fea"+nr] ) // extraprocess MPadJava
    {
      win.m[nr] = win.document.applets["fea"+nr].getMPad();
      continue;
    }
    if ( win.Type[nr] == 0 && !SGetElA(nr) ) // MCR (test wg. step)
      continue;
    else if ( win.Type[nr] == 0 || win.Type[nr] == 3) // MCR + VR
    {
      win.m[nr] = -1;
      var i = 0;
      while ( SGetElAI(nr, i) )
      {
        if ( SGetElAI(nr, i).checked )
          win.m[nr] = i;
        i++;
      }
    }
    else if ( win.Type[nr] == 1 ) // MCP
      win.m[nr] = SGetElA(nr).options.selectedIndex;
    else if ( win.Type[nr] == 2 ) // MCX
    {
      if ( win.d[nr].length == 1 )
        win.m[nr][0] = (SGetElA(nr).checked) ? "1" : "0";
      else
        for (i=0; i < win.d[nr].length; i++)
          win.m[nr][i] = (SGetElAI(nr, i).checked) ? "1" : "0";
    }
    else if ( win.Type[nr] <= 6 ) // VR - LT
      win.m[nr] = SGetElA(nr).value;
  }
  return DataToString(win.m);
}

function StoreSoft(TheWin)
{
  win = TheWin;
  if ( !win.Type )
    return;
  return DataToString(win.Result)+"\x04"+
    DataToString(win.Solved)+"\x04"+
    DataToString(win.nSolve)+"\x04"+
    DataToString(win.iHint)+"\x04"+
    DataToString(win.iFHint)+"\x04"+
    (win.SolvedM ? DataToString(win.SolvedM) : "")+"\x04"+
    DataToString(StorePF());
}

function Restore(TheWin, sDataHard1, sDataSoft1)
{
  win = TheWin;
  sDataHard = sDataHard1;
  sDataSoft = sDataSoft1;
  RestoreWin();
}

function RestoreWin()
{
  if ( !win ||
       !win.document ||
       !win.document.forms[0] ||
       !win.document.forms[0].elements )
  {
    setTimeout("RestoreWin()", 500);
    return;
  }
  if ( !win.Type || sDataHard == "" )
    return;
  var arr = sDataHard.split("\x04");
  win.m = StringToData(arr[0]);
  for (var nr = 0; nr < win.Type.length && nr < win.m.length; nr++)
  {
    if ( eval("win.document.sr"+nr) && win.m[nr] != "" ) // preprocess SR (MCA)
      eval("win.document.sr"+nr).setValue(win.m[nr]);
    if ( win.document.applets["fea"+nr] ) // extraprocess MPadJava
    {
      win.document.applets["fea"+nr].setMPad(win.m[nr]);
      if ( SGetElA(nr) )
        SGetElA(nr).value = win.m[nr];
      continue;
    }
    if ( win.Type[nr] == 0 && !SGetElA(nr) ) // MCR (test wg. step)
      continue;
    if ( win.Type[nr] == 0 || win.Type[nr] == 3 ) // MCR + VR
    {
      if ( win.m[nr] != -1 && SGetElAI(nr, win.m[nr]) != 0 )
        SGetElAI(nr, win.m[nr]).checked = true;
    }
    if ( win.Type[nr] == 1 ) // MCP
      SGetElA(nr).options.selectedIndex = win.m[nr];
    else if ( win.Type[nr] == 2 ) // MCX
    {
      if ( win.d[nr].length == 1 )
        SGetElA(nr).checked = (win.m[nr][0] == 1);
      else
        for (i=0; i < win.m[nr].length; i++)
          SGetElAI(nr, i).checked = (win.m[nr][i] == 1);
    }
    else if ( win.Type[nr] <= 7 ) // VR - TF
      SGetElA(nr).value = win.m[nr];
    else if ( win.Type[nr] == 8 ) // TFM
      SGetElA(nr).value = win.m[nr][0];
    else if ( win.Type[nr] == 9 ) // TLS
      win.SetTLSEntry(nr, win.m[nr]);
    else if ( win.Type[nr] == 10 ) // TLM
      win.RefreshTLM(nr);
  }
  for (var nr = 0; nr < win.Type.length; nr++)
    if ( win.Type[nr] == 11 || win.Type[nr] == 13 || win.Type[nr] == 14 ) // SLS (ZO, FZO)
      win.RefreshSLS(nr);
  if ( sDataSoft )
  {
    var arr = sDataSoft.split("\x04");
    win.Result = StringToData(arr[0]);
    win.Solved = StringToData(arr[1]);
    win.nSolve = StringToData(arr[2]);
    if ( win.iHint )
      win.iHint = StringToData(arr[3]);
    if ( win.iFHint )
      win.iFHint = StringToData(arr[4]);
    if ( win.SolvedM )
      win.SolvedM = StringToData(arr[5]);
    RestorePF(StringToData(arr[6]));
  }
}

// Array to String

function DataToString(a)
{
  if ( typeof a == "string" )
    return '\x05'+escape(a)+'")';
  else if ( typeof a == "number" )
    return a;
  else  if ( typeof a == "object" )
  {
    var s = "\x06"
    for (var i = 0; i < a.length; i++)
      s += ","+DataToString(a[i]);
    return s+")";
  }
  else
    return a;
}

function ChopArrays(a)
{
  if ( typeof a == "object" )
  {
    var b = new Array();
    for (var i = 1; i < a.length; i++)
      b[b.length] = ChopArrays(a[i]);
    return b;
  }
  else
    return a;
}

function StringToData(s)
{
  return ChopArrays(eval(s.replace(/\x05/g, 'unescape("').replace(/\x06/g, 'new Array(0')));
}

// PF sichern

function GetTag(name) {
  return ie ? eval('win.document.all.'+name) : win.document.getElementById(name);
}

function GetTagA(nr) {
  return GetTag('a'+nr);
}

function GetTagAI(nr, i) {
  return GetTag('a'+nr+'_'+i);
}

function StorePF()
{
  if ( lay )
    return;
  var t;
  pf = new Array();
  for (var nr = 0; nr < win.Type.length && nr < win.m.length; nr++)
    if ( win.document.applets["fea"+nr] ) // extraprocess MPadJava
      pf[nr] = win.document.applets["fea"+nr].getBgColor();
    else if ( GetTagAI(nr, 0) )
    {
      pf[nr] = new Array();
      var i = 0;
      while ( t = GetTagAI(nr, i) )
        pf[nr][i++] = t.style.backgroundColor;
    }
    else if ( t = GetTagA(nr) )
      pf[nr] = t.style.backgroundColor;
  return pf;
}

function RestorePF(pf)
{
  if ( lay )
    return;
  var t;
  for (var nr = 0; nr < win.Type.length && nr < win.m.length; nr++)
    if ( pf[nr] )
      if ( win.document.applets["fea"+nr] ) // extraprocess MPadJava
        win.document.applets["fea"+nr].setBgColor(pf[nr]);
      else if ( GetTagAI(nr, 0) )
      {
        var i = 0;
        while ( (t = GetTagAI(nr, i)) && pf[nr][i] )
          t.style.backgroundColor = pf[nr][i++];
      }
      else if ( t = GetTagA(nr) )
        t.style.backgroundColor = pf[nr];
}

