// Glossar --------------------------------------------------------------------

var GlossWord = 0;
var GlossId = 0;
var GlossEntry = 0;

var LastGotoGloss = -1;

var TopSep = "<BR><FONT face=\"Symbol\">&#174;</FONT> <X>top";

function InitGlossar(Words, Ids, Entries)
{
  GlossWord = Words;
  GlossId = Ids;
  GlossEntry = Entries;
  ShowGlossar();
}

function IsMain(i)
{
  return GlossId[i].charAt(0) != '0' || GlossId[i].length == 1;
}

function ShowGlossar()
{
  var sTop = '<BODY style="margin-top:4px; margin-bottom:4px;font-family:Arial;"><B><FONT size=4>';
  var sBody = '<HTML><HEAD>'+top.control.ISO+'</HEAD><BODY style="font-family:Arial;"><TABLE border=0>';
  var NextLetter = 0;
  var lay = document.layers;
  for (var i = 0; i < GlossWord.length; i++)
  {
    while ( NextLetter < LetterStart.length && LetterStart[NextLetter] == -1 )
    {
      sTop += (( NextLetter != 0 ) ? "&nbsp;" : "" ) +
              '<font color="#C0C0C0">'+Letter[NextLetter++]+'</FONT>';
    }
    if ( NextLetter < LetterStart.length && LetterStart[NextLetter] == i )
    {
      sTop += (( NextLetter != 0 ) ? "&nbsp;" : "" ) +
              '<A href="javascript:parent.glossdata.GotoGloss(\'l' + i + '\')">' +
              Letter[NextLetter]+'</A>';
      sBody += '<TR><TD colspan=2 id="il' + i + '">' +
               (lay ? '<BR><ILAYER name="l' + i + '">' : '<A name="l'+ i +'"><BR>') +
               '<B><font size=5>'+Letter[NextLetter++]+'</FONT></B>' +
               (lay ? '</ILAYER>' : '</A>') +
               '</TD></TR>';
    }
    var Id = 1*GlossId[i];
    var sSynonym = "";
    for (var j = 0; j < GlossWord.length; j++)
      if ( GlossId[j] == Id && j != i )
        if ( IsMain(j) )
          sSynonym += ' <A href="javascript:parent.glossdata.GotoGloss(\'w'+j+'\')"><B>'+GlossWord[j]+'</B></A>;';
        else
          sSynonym += ' '+GlossWord[j]+';';
    sBody += '<TR><TD valign="top" id="iw' + (1*i) + '">' +
             (lay ? '<ILAYER name="w' + (1*i) + '">' : '<A name="w' + (1*i) + '">') +
             '<B>'+GlossWord[i]+'</B>' +
             (lay ? '</ILAYER>' : '</A>') +
             '</TD><TD valign="top">';
    if ( IsMain(i) )
    {
      var k = GlossEntry[Id].indexOf(TopSep);
      if ( k == -1 )
      {
        ge1 = GlossEntry[Id];
        ge2 = "";
      }
      else
      {
        ge1 = GlossEntry[Id].substr(0, k);
        ge2 = '<font size="2">'+GlossEntry[Id].substr(k)+'</font>';
      }
      sBody += ge1 + (sSynonym != '' ? '<BR><B>Synonym:</B>'+sSynonym : '') + ge2;
    }
    else
      sBody += (sSynonym != '' ? '<B>Synonym:</B>'+sSynonym : '')
    sBody += "</TD></TR>";
  }
  // restliche Graue Buchstaben
  while ( NextLetter < Letter.length )
  {
    sTop += (( NextLetter != 0 ) ? "&nbsp;" : "" ) +
            '<font color="#C0C0C0">'+Letter[NextLetter++]+'</FONT>';
  }
  sBody += "</TABLE></BODY></HTML>";
  sBody = sBody.replace(/<X>/g, '<A href="javascript:parent.glossdata.GotoGloss(\'w');
  sBody = sBody.replace(/<Y>/g, '\')">');
  sBody = sBody.replace(/<Z>/g, '</A>');
  sBody = sBody.replace(/href="javascript:parent.glossdata.GotoGloss\(\'wtop/g,
            'target="control" href="javascript:SetTopic(\'');
  sTop += "</FONT></B></BODY>"
  doc = parent.glossbody.document;
  doc.open();
  doc.writeln(sBody);
  doc.close();
  doc = parent.glosstop.document;
  doc.open();
  doc.writeln(sTop);
  doc.close();
  LastGotoGloss = -1;
  if ( parent.location.hash != "" )
    setTimeout("GotoGloss('w"+parent.location.hash.substring(1)+"')", 20);
}

function GotoGloss(anc)
{
//  top.control.AddHistory(top.control.Mode, top.control.MedTopic, top.control.MedI, anc);
  if ( document.layers )
  {
    if ( LastGotoGloss && LastGotoGloss != -1 )
      LastGotoGloss.bgColor = "#FFFFFF";
    LastGotoGloss =  eval('parent.glossbody.document.' + anc);
    parent.glossbody.scrollTo(0, LastGotoGloss.pageY-80);
    LastGotoGloss.bgColor = "#FF0000";
    return;
  }
  if ( LastGotoGloss != -1 )
    LastGotoGloss.style.color = "";
  if ( document.all )
    LastGotoGloss = eval("parent.glossbody.document.all."+anc);
  else if ( document.getElementsByName )
    LastGotoGloss = parent.glossbody.document.getElementsByName(anc)[0];
  else
    return;
  if ( LastGotoGloss.scrollIntoView )
    LastGotoGloss.scrollIntoView();
  else
    parent.glossbody.scrollTo(0, parent.glossbody.document.getElementById("i"+anc).offsetTop-80);
  LastGotoGloss.style.color = "#CC0000";
}
