// Plans

var PlanNr = -1;   // aktueller Plan
var PlanPos = -1;  // Listenposition im aktuellen Plan

// Lernplan ---------------------------------------------------------

var PlanImg = new Array(new Image(), new Image());
var PlanTooltip = new Array("Als noch nicht gelernt markiert. (Klicken zum Umschalten.)", "Als gelernt markiert. (Klicken zum Umschalten.)");
var PlanTooltipS = new Array("Als noch nicht gelernt markiert.", "Als gelernt markiert.");

function MovePlan(delta)
{
  if ( PlanNr != -1 && PlanPos != -1)
  {
    PlanPos += delta;
    if ( PlanPos < 0 )
      PlanPos = 0;
    if ( PlanPos >= Plan[PlanNr].length-2 )
      PlanPos = Plan[PlanNr].length-3;
    var a = Plan[PlanNr][PlanPos+2].split("&");
    var b = a[0].split(".");
    if ( b[0] == M_TEXT )
    {
      Mode = M_TEXT;
      SetTopic(b[1]);
      return;
    }
    StartMedia(b[0], b[1], b[2]);
    setTimeout("ShowTitle()", 30);
    setTimeout("ShowCont()", 40);
  }
}

function CheckUpdatePlanPos(mode, nr, i)
{
  PlanPos = -1;
  if ( PlanNr == -1 )
    return;
  if ( mode != M_TEXT && mode < M_MEDIAOPEN )
    return;
  var m = mode % M_MEDIAOPEN;
  for (var j = 0; j < Plan[PlanNr][0]; j++)
  {
    var a = Plan[PlanNr][j+2].split("&");
    var b = a[0].split(".");
    if ( b[0] == m && b[1] == nr && (m == M_TEXT || b[2] == i) )
    {
      PlanPos = j;
      return;
    }
  }
}

function PlanCheckbox(nr, pos)
{
  if ( nr != -1 && pos != -1)
  {
    var a = Plan[nr][pos+2].split("&");
    var sTooltip = PlanTooltip[a[1]];
    return '<A href="javascript:top.control.SwitchPlan(' + nr + ', ' + pos + ')" target="control" '+MouseTip(sTooltip)+'>'+
           '<img src="'+base+'../Data/planboxl'+a[1]+'.gif" border=0 alt="'+ sTooltip + '" align="top"></a>';  //absmiddle
  }
  else
    return '';
}

function GetPlanTooltip(nr, pos)
{
  var a = Plan[nr][pos+2].split("&");
  return PlanTooltip[a[1]];
}

function PlanCheckbox2(nr, pos)
{
  if ( nr != -1 && pos != -1)
  {
    var a = Plan[nr][pos+2].split("&");
    var sTooltip = PlanTooltip[a[1]];
    return '<a href="javascript:top.control.SwitchPlan(' + nr + ', ' + pos + ', top.data.display.document.plan'+pos+', this)" target="control" title="' + sTooltip + '" onMouseOver="status=top.control.GetPlanTooltip(' +
           nr + ', ' + pos + '); return true;" onMouseOut="status=\'\'; return true;">'+
           '<img src="'+base+'../Data/planboxb'+a[1]+'.gif" border=0 alt="'+ sTooltip + '" name=plan'+pos+'></a>';
  }
  else
    return '';
}

function CurPlanCheckbox()
{
  return PlanCheckbox(PlanNr, PlanPos);
}

function SwitchPlan(nr, pos, img, alink)
{
  var a = Plan[nr][pos+2].split("&");
  a[1] = 1-a[1];
  Plan[nr][pos+2] = a.join("&");
  if ( Mode != M_PLAN )
  {
    setTimeout("ShowCont()", 20);
    setTimeout("ShowButtons()", 10);
  }
  else if ( img )
  {
    img.src = PlanImg[a[1]].src;
    img.alt = PlanTooltip[a[1]];
    alink.title = PlanTooltip[a[1]];
    setTimeout("ShowCont()", 20);
  }
  S2sSend("plan", "SWITCH "+nr+" "+pos+" "+a[1]);
}

function CheckPlan()
{
  if ( PlanNr == -1 )
  {
    if ( Plan.length == 0 )
      Plan[0] = new Array(0, "unbenannt");
    PlanNr = 0;
  }
}

function PlanSelection(add)
{
  var res = '<select name="Plan">\r\n';
  for (var i = 0; i < Plan.length; i++)
    res += '<option' + ((i == PlanNr) ? " selected" : "") + '> ' + (Plan[i][1].split("\x01")[0]) + '<BR>\r\n';
  res += add+' </select>\r\n';
  return res;
}

function AddPlan(medium, topic, nr)
{
  CheckPlan();
  var TheTitle = Name[topic];
  if ( medium < M_TEXT )
    TheTitle = Media[medium][topic][nr][1];
  NewDia(
    'Zu Lernplan hinzufgen',
    '<b>' + TheTitle + '</b> (' + GetMediaTitleShort(medium) + ')<P>' +
    'in Lernplan ' +
    PlanSelection('') +
    '<p>\r\n' +
    'Kommentar<BR>\r\n<textarea name="Comment" cols="45" rows="5"></textarea>\r\n' +
    '<p align="right"><input type="button" value="Hinzufgen" onClick="Add()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function Add()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.AddPlanOk(' + medium + ',' + topic + ',' + nr +
    ', fm.Plan.selectedIndex, fm.Comment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    420, 300, 200, 200, 1);
}

function AddPlanOk(medium, topic, nr, iPlan, comment)
{
  Plan[iPlan][2+(Plan[iPlan][0]++)] = "" + medium + '.' + topic + '.' + nr + '&0&' + comment;
  PlanNr = iPlan;
  if ( Mode != M_PLAN )
  {
    setTimeout("ShowCont()", 20);
    setTimeout("ShowButtons()", 10);
  }
  S2sSend("plan", "ADD "+iPlan+" "+medium+" "+topic+" "+nr+" "+comment);
}

function RemovePlan(nr, pos)
{
  for (var i = pos+2; i < Plan[nr][0]+1; i++)
    Plan[nr][i] = Plan[nr][i+1];
  Plan[nr][0]--;
  if ( Mode != M_PLAN )
  {
    setTimeout("ShowCont()", 20);
    setTimeout("ShowButtons()", 10);
  }
  else //if ( Mode == M_PLAN )
  {
    DiaWin.close();
    setTimeout("ShowPlan()", 10);
  }
  S2sSend("plan", "ERASE "+nr+" "+pos);
}


function EditPlanEntry(nr)
{
  var Task = Plan[PlanNr][nr+2].split("&");
  var What = Task[0].split(".");
  var TheTitle = Name[What[1]];
  if ( What[0] < M_TEXT )
    TheTitle = GetMedia(What[0], What[1])[What[2]][1];
  NewDia(
    'Lernplaneintrag lschen/verschieben',
    '<b>' + TheTitle + '</b> (' + GetMediaTitleShort(What[0]) + ')<P>' +
    '<table><tr><td>Den Eintrag</td><td>' +
    '<input type="button" value="Lschen" onClick="ReturnWin.RemovePlan(' + PlanNr + ', '+ nr +')"></td></tr>\r\n' +
    '<tr><td colspan=2><hr></td><tr>' +
    '<tr><td>Den Eintrag an die <input type=text name="Nr" size=3>. Stelle&nbsp;'+
    '</td><td><input type="button" value="Verschieben" onClick="ReturnWin.MovePlanEntry(' +
    nr +', Nr.value-1)"></td></tr>\r\n' +
    '</table>\r\n' +
    '<hr><o align="right"><input type="button" value="Abbruch" onClick="self.close()"></p>',
    ' ',
    400, 300, 200, 200, -1);
}

function MovePlanEntry(nr, toNr)
{
  var s = Plan[PlanNr][nr+2];
  var i;
  if ( nr < toNr )
  {
    for (i = nr; i < Plan[PlanNr][0]-1 && i < toNr; i++)
      Plan[PlanNr][i+2] = Plan[PlanNr][i+3];
    Plan[PlanNr][i+2] = s;
  }
  else if ( toNr < nr )
  {
    for (i = nr; i > toNr; i--)
      Plan[PlanNr][i+2] = Plan[PlanNr][i+1];
    Plan[PlanNr][i+2] = s;
  }
  DiaWin.close();
  setTimeout("ShowPlan()", 10);
  S2sSend("plan", "MOVE "+PLanNr+" "+nr+" "+toNr);
}

function CommentPlan(nr)
{
  var Task = Plan[PlanNr][nr+2].split("&");
  var What = Task[0].split(".");
  var TheTitle = Name[What[1]];
  if ( What[0] < M_TEXT )
    TheTitle = GetMedia(What[0], What[1])[What[2]][1];
  NewDia(
    'Kommentar bearbeiten',
    '<b>' + TheTitle + '</b> (' + GetMediaTitleShort(What[0]) + ')<p>' +
    'Kommentar<br>\r\n<textarea name="Comment" cols="45" rows="5">' +
    Task[2] +
    '</textarea>\r\n' +
    '<p align="right"><input type="button" value="  Ok  " onClick="Edit()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></p>',
    'function Edit()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.CommentPlanOk(' + PlanNr + ',' + nr + ', fm.Comment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    420, 270, 200, 200, 0);
}

function CommentPlanOk(plan, nr, comment)
{
  var Task = Plan[plan][nr+2].split("&");
  Plan[plan][nr+2] = Task[0] + '&' + Task[1] + '&' + comment;
  if ( Mode == M_PLAN )
    setTimeout("ShowPlan()", 10);
  S2sSend("plan", "COMMENT "+plan+" "+nr+" "+comment);
}

function RenamePlan()
{
  var planData = Plan[PlanNr][1].split("\x01");
  NewDia(
    'Lernplan umbenennen',
    'Neuer Name<br>' +
    '<input type=text name="NewName" size=45 maxlength=45 value="' +
    planData[0] +
    '">' +
    '<br>Bemerkung<br>' +
    '<textarea name="NewComment" cols=45 rows=5>' +
    (planData.length > 1 ? planData[1] : '')+
    '</textarea>' +
    '<p align="right"><input type="button" value="  Ok  " onClick="Rename()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></p>',
    'function Rename()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.RenamePlanOk(' + PlanNr + ', fm.NewName.value, fm.NewComment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    480, 230, 200, 200, 0);
}

function RenamePlanOk(plan, name, comment)
{
  Plan[plan][1] = name + (comment != '' ? '\x01'+comment : '');
  if ( Mode == M_PLAN )
    setTimeout("ShowPlan()", 10);
  S2sSend("plan", "RENAME "+plan+" "+name);
}

var DiaClosed = 1;

function SelectPlan()
{
  NewDia(
    'Lernplan auswhlen',
    'Lernplan<br>' +
    PlanSelection('<option>kein Plan</option>') +
    '<p align="right"><input type="button" value="  Ok  " onClick="SelectIt()">\r\n' +
    '<input type="button" value=" Neu " onClick="New()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></p>',
    'function SelectIt()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.SelectPlanOk(fm.Plan.selectedIndex);\r\n' +
    '  self.close();\r\n' +
    '}\r\n' +
   'function New()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.NewPlan();\r\n' +
    '}\r\n',
     420, 160, 200, 200, 0);
  DiaClosed = 0;
}

function SelectPlanOk(plan)
{
  if ( plan >= Plan.length )
  {
    PlanNr = -1;
    setTimeout("ChangeMode(M_TEXT)", 10);
    setTimeout("ShowCont()", 20);
  }
  else
  {
    PlanNr = plan;
    if ( Mode == M_PLAN )
      setTimeout("ShowPlan()", 10);
  }
}


function NewPlan()
{
  if ( DiaWin && !DiaWin.closed )
  {
    if ( DiaClosed == 0 )
    {
      DiaClosed = 1;
      DiaWin.close();
    }
    setTimeout('NewPlan()', 200);
  }
  NewDia(
    'Neuer Lernplan',
    'Name des neuen Lernplans<br>' +
    '<input type=text name="NewName" size=45 maxlength=45 value="">' +
    '<br>Bemerkung<br>' +
    '<textarea name="NewComment" cols=45 rows=5></textarea>' +
    '<p align="right"><input type="button" value="  Ok  " onClick="New()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></p>',
    'function New()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.NewPlanOk(fm.NewName.value, fm.NewComment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    480, 230, 200, 200, 0);
}

function NewPlanOk(name, comment)
{
  Plan[Plan.length] = new Array(0, name + (comment != '' ? '\x01'+comment : ''));
  PlanNr = Plan.length-1;
  if ( Mode == M_PLAN )
    setTimeout("ShowPlan()", 10);
  S2sSend("plan", "NEW "+PlanNr+" "+name+" "+comment);
}

function KillPlan()
{
  if ( confirm('Soll der Lernplan "' + (Plan[PlanNr][1].split("\x01")[0]) +'" wirklich gelscht werden?') )
  {
    var s2s_help = PlanNr; // s2send
    Plan = Plan.slice(0, PlanNr-1).concat(Plan.slice(PlanNr+1, Plan.length-1));
/*    for (var i = curSheets; i < nSheets-1; i++)
      Sheets[i] = Sheets[i+1];
    nSheets--;*/
    PlanNr = -1;
    CheckPlan();
    setTimeout("ShowPlan()", 10);
    S2sSend("plan", "KILL "+s2s_help);
  }
}

function PlanTOC(topic, deepLimit)
{
  if ( !UsePlan || PlanNr == -1 )
    return '';
  var topicEnd;
  for (topicEnd = topic+1; topicEnd < nTopic; topicEnd++)
    if ( Deep[topicEnd] <= deepLimit )
      break;
  var n = new Array(0, 0);
  for (var j = 0; j < Plan[PlanNr][0]; j++)
  {
    var a = Plan[PlanNr][j+2].split("&");
    var b = a[0].split(".");
    if ( topic <= b[1] && b[1] < topicEnd )
      n[a[1]]++;
  }
  var i = n[0] != 0 ? 1 : 0;
  if ( n[1] != 0 )
    i += 2;
  var s = "<td>" + ( i != 0 ? '<img src="planbox'+(i-1)+'.gif">' : "<b></b>") +
    '</td><td>' + ( i != 0 ? '<nobr><font size=1>&nbsp;'+(i == 3 ? n[1]+'/' : '')+(n[0]+n[1])+'</font></nobr>' : "<b></b>") +
    '</td>';
  return s;
}

function GetPlanCheckbox(mode, nr, i)
{
  if ( !UsePlan || PlanNr == -1 )
    return '';
  var m = '';
  if ( mode == M_TEXT )
    m = ''+M_TEXT+'.'+nr+'.0';
  else if ( mode > M_MEDIAOPEN )
    m = ''+(mode % M_MEDIAOPEN)+'.'+nr+'.'+i;
  else
    return '';
  for (var j = 0; j < Plan[PlanNr][0]; j++)
  {
    var a = Plan[PlanNr][j+2].split("&");
    if ( a[0] == m )
      return ' <img src="'+base+'../Data/planbox'+a[1]+'.gif" '+(ie||lay?'alt':'title')+'="'+PlanTooltipS[a[1]]+'">';
  }
  return '';
}

function ShowPlan()
{
  CheckPlan();
  while ( !top.data.display );
  var doc = top.data.display.document;
  doc.open();
  var planData = Plan[PlanNr][1].split("\x01");
  doc.writeln(DISPLAY_HEADER_BODY,
    '<p onClick="top.control.RenamePlan()"><span class="planTitle">',
    planData[0],
    '</span>', planData.length > 1 ? ' &nbsp; ('+planData[1]+')' : '' , '</p>\r\n',
    '<form><table border="1" cellspacing="1" cellpadding="4">\r\n',
    '<tr>\r\n',
    '<td class="planHead">&Auml;ndern</td>\r\n',
    '<td class="planHead">Medium</td>\r\n',
    '<td class="planHead">Titel</td>\r\n',
    '<td class="planHead"> &nbsp; </td>\r\n',
    '<td class="planHead">Kommentar</td>\r\n',
    '</tr>\r\n');
  for (var i = 0; i < Plan[PlanNr][0]; i++)
  {
    var Task = Plan[PlanNr][i+2].split("&");
    var What = Task[0].split(".");
    doc.writeln('<TR>\r\n',
      '<td valign="top" align="center"><input type="button" value="  ', i+1, '.  " ',
      ' onClick="top.control.EditPlanEntry(', i, ')"></td>\r\n',
      '<td valign="top">', GetMediaTitleShort(What[0]), '</td>');
    if ( What[0] == M_TEXT )
    {
      if ( Available(What[1]) )
        doc.writeln('<td valign="top"><a href="javascript:top.control.SetTopic(' + What[1] + ', ' + M_TEXT + ')" title="Lehrtext">',
          Name[What[1]], '</a></td>');
      else
        doc.writeln('<td valign="top"><font color=#666666>', Name[What[1]], '</td>');
    }
    else
      doc.writeln('<td valign="top">', MediaLink(What[0], What[1], What[2]), '</td>');
    doc.writeln(
      '<td valign=top>'+PlanCheckbox2(PlanNr, i)+
      '</td><td valign="top" class="planComment"><span onClick="top.control.CommentPlan(', i, ')">',
      InsertBR(Task[2]),
      '&nbsp;</span></td></tr>');
  }
  doc.writeln('</table></form></body>');
  doc.close();
}


